package form_faces.actions;

import formFaces.action.*;
import formFaces.excepcio.*;
import form_faces.ServiceLocator;
import form_faces.classes.*;
import logica.LogicaFacade;
import integracio.baseDades.*;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

public class AssigOperari implements Action {
	
	public void execute(ActionForm af) throws Exception{
		String operari = af.getValor("operari");
		LogicaFacade lf = ServiceLocator.getInstance().getFacade();
		Tasques t = lf.getTascaActual(af.getValor("maquina"));
		if (operari==null || lf.getNomOperari(operari)==null){
			af.novaExcepcio(new FormFacesExcepcio("Operari "+operari+" no existeix",3));
		} else {
			String maq = lf.estaAssignat(operari);
			if (!maq.equalsIgnoreCase("")){
				af.novaExcepcio(new FormFacesExcepcio("L'operari "+operari+" ja est assignat a la mquina "+maq,3));
			} else {
				if (t == null){
					t = lf.novaTasca(af.getValor("maquina"),operari);
				} else {
					t.addAssignats(operari);
				}
			}
		}
		if (t!=null){
			List<String> opes = t.getAssignats(); 
			List<Classe> ops = new ArrayList<Classe>();
			for (Iterator<String> it = opes.iterator(); it.hasNext();){
				String op = it.next();
				Operari o = new Operari();
				o.setValor("codi", op);
				o.setValor("nom", lf.getNomOperari(op));
				ops.add(o);
			}
			af.setLlista("operaris", ops);
		}
	}
}
