package form_faces.actions;

import formFaces.action.*;
import form_faces.ServiceLocator;
import form_faces.classes.*;
import logica.LogicaFacade;
import integracio.baseDades.*;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

public class SelMaquina implements Action {
	
	public void execute(ActionForm af) throws Exception{
		LogicaFacade lf = ServiceLocator.getInstance().getFacade();
		Tasques t = lf.getTascaActual(af.getValor("maquina"));
		if (t != null){
			List<String> opes = t.getAssignats(); 
			List<Classe> ops = new ArrayList<Classe>();
			for (Iterator<String> it = opes.iterator(); it.hasNext();){
				String op = it.next();
				Operari o = new Operari();
				o.setValor("codi", op);
				o.setValor("nom", lf.getNomOperari(op));
				ops.add(o);
			}
			af.setLlista("operaris", ops);
			if (t.getOrdreActual()==0){
				List<Ordres> ordres = lf.getOrdres();
				List<Classe> ors = new ArrayList<Classe>();
				for (Iterator<Ordres> it = ordres.iterator(); it.hasNext();){
					Ordres or = it.next();
					for (Iterator<Fases> itf = or.getFases().iterator(); itf.hasNext();){
						Fases f = itf.next();
						if (f.getMaquina().equalsIgnoreCase(af.getValor("maquina")) && or.getPendentFase(f.getNumFase())>0){
							Treball tr = new Treball();
							tr.setValor("maquina", af.getValor("maquina"));
							tr.setValor("ordre", String.valueOf(or.getCodi()));
							tr.setValor("fase", String.valueOf(f.getNumFase()));
							tr.setValor("pendent", String.valueOf(or.getPendentFase(f.getNumFase())));
							tr.setValor("article", or.getArticle());
							tr.setValor("descripcio", lf.getDescripcioArticle(or.getArticle()));
							ors.add(tr);
						}
					}
				}
				af.setLlista("ordres", ors);
			} else {
				Treball tr = new Treball();
				Ordres o = lf.getOrdre(t.getOrdreActual());
				tr.setValor("maquina", af.getValor("maquina"));
				tr.setValor("ordre", String.valueOf(t.getOrdreActual()));
				tr.setValor("fase", String.valueOf(t.getFaseActual()));
				tr.setValor("pendent",	String.valueOf(o.getPendentFase(t.getFaseActual())));
				tr.setValor("article", o.getArticle());
				tr.setValor("descripcio", lf.getDescripcioArticle(o.getArticle()));
				af.setClasse("treball", tr);
				List<Components> c = o.getComponents();
				List<Classe> cs = new ArrayList<Classe>();
				for (Iterator<Components> it=c.iterator();it.hasNext();){
					Components co = it.next();
					if (co.getFase()==t.getFaseActual()){
						Component com = new Component();
						com.setValor("component", co.getComponent());
						com.setValor("descripcio", lf.getDescripcioArticle(co.getComponent()));
						com.setValor("qtUnitaria", String.valueOf(co.getQuantitatUnitaria()));
						cs.add(com);
					}
				}
				af.setLlista("components", cs);
			}
		}
	}

}
