package form_faces.actions;

import formFaces.action.*;
import form_faces.ServiceLocator;
import form_faces.classes.*;
import logica.LogicaFacade;
import integracio.baseDades.*;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

public class SelOrdre implements Action {
	
	public void execute(ActionForm af) throws Exception{
		LogicaFacade lf = ServiceLocator.getInstance().getFacade();
		String maquina = lf.getMaquina(Long.parseLong(af.getValor("ordre")), Integer.parseInt(af.getValor("fase")));
		Tasques t = lf.getTascaActual(maquina);
		if (t != null){
			t.setOrdreActual(Long.parseLong(af.getValor("ordre")));
			t.setFaseActual(Integer.parseInt(af.getValor("fase")));
			List<String> opes = t.getAssignats(); 
			List<Classe> ops = new ArrayList<Classe>();
			for (Iterator<String> it = opes.iterator(); it.hasNext();){
				String op = it.next();
				Operari o = new Operari();
				o.setValor("codi", op);
				o.setValor("nom", lf.getNomOperari(op));
				ops.add(o);
			}
			af.setLlista("operaris", ops);
			Treball tr = new Treball();
			Ordres o = lf.getOrdre(t.getOrdreActual());
			tr.setValor("maquina", maquina);
			tr.setValor("ordre", String.valueOf(t.getOrdreActual()));
			tr.setValor("fase", String.valueOf(t.getFaseActual()));
			tr.setValor("pendent",	String.valueOf(o.getPendentFase(t.getFaseActual())));
			tr.setValor("article", o.getArticle());
			tr.setValor("descripcio", lf.getDescripcioArticle(o.getArticle()));
			af.setClasse("treball", tr);
			List<Components> c = o.getComponents();
			List<Classe> cs = new ArrayList<Classe>();
			for (Iterator<Components> it=c.iterator();it.hasNext();){
				Components co = it.next();
				if (co.getFase()==t.getFaseActual()){
					Component com = new Component();
					com.setValor("component", co.getComponent());
					com.setValor("descripcio", lf.getDescripcioArticle(co.getComponent()));
					com.setValor("qtUnitaria", String.valueOf(co.getQuantitatUnitaria()));
					cs.add(com);
				}
			}
			af.setLlista("components", cs);
		} else {
			List<Maquines> mqs = lf.getMaquines();
			List<Classe> maqs = new ArrayList<Classe>();
			for (Iterator<Maquines> it = mqs.iterator(); it.hasNext();){
				Maquines mq = it.next();
				Maquina m = new Maquina();
				m.setValor("codi", mq.getCodi());
				m.setValor("descripcio", mq.getDescripcio());
				maqs.add(m);
			}
			af.setLlista("maquines", maqs);
		}
	}

}
