package integracio.baseDades;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

public class GestorDB {
	private static GestorDB db;
	
	public static GestorDB getDB(){
		if(db==null) db = new GestorDB();
		return db;
	}
	private Hashtable<String, String> articles;
	private Hashtable<String, Operaris> operaris;
	private List<Maquines> maquines;
	private List<Ordres> ordres;
	private List<Tasques> tasques;
	
	public GestorDB(){
		articles = new Hashtable<String, String>();
		articles.put("10120", "Pea acabada 1");
		articles.put("10121", "Pea acabada 2");
		articles.put("20001", "Pintura blanca");
		articles.put("20002", "Pintura negra");
		articles.put("30010", "Cargols");
		articles.put("30011", "Famelles");
		articles.put("40010", "Caixa cartr");
		articles.put("15010", "Semielaborat 1");
		articles.put("15011", "Semielaborat 2");
		articles.put("50001", "Alumini");
		articles.put("60001", "Perfils");
		operaris = new Hashtable<String, Operaris>();
		operaris.put("001", new Operaris("001", "Joan"));
		operaris.put("002", new Operaris("002", "Pere"));
		operaris.put("003", new Operaris("003", "Raul"));
		operaris.put("004", new Operaris("004", "Lluis"));
		operaris.put("005", new Operaris("005", "Ignasi"));
		operaris.put("006", new Operaris("006", "Pepita"));
		maquines = new ArrayList<Maquines>();
		maquines.add(new Maquines("PI", "Tunel Pintura"));
		maquines.add(new Maquines("FO", "Foneria"));
		maquines.add(new Maquines("MU", "Muntatge"));
		maquines.add(new Maquines("TA", "Tall"));
		ordres = new ArrayList<Ordres>();
		Ordres o = new Ordres(10201, "10120", 10);
		o.addFase(new Fases(1, "PI", 3, (float)0.23));
		o.addFase(new Fases(2, "MU", 2, (float)5.3));
		o.addComponent(new Components("20001", 1, (float)0.34));
		o.addComponent(new Components("15010", 1, (float)1));
		o.addComponent(new Components("30010", 2, (float)4));
		o.addComponent(new Components("30011", 2, (float)4));
		o.addComponent(new Components("40010", 2, (float)0.5));
		ordres.add(o);
		Ordres o3 = new Ordres(10203, "10121", 15);
		o3.addFase(new Fases(1, "PI", 3, (float)0.44));
		o3.addFase(new Fases(2, "MU", 2, (float)8));
		o3.addComponent(new Components("20002", 1, (float)0.45));
		o3.addComponent(new Components("15011", 1, (float)1));
		o3.addComponent(new Components("30010", 2, (float)2));
		o3.addComponent(new Components("30011", 2, (float)2));
		o3.addComponent(new Components("40010", 2, (float)0.5));
		ordres.add(o3);
		Ordres o2 = new Ordres(10202, "15010", 20);
		o2.addFase(new Fases(1, "FO", 1, (float)10.2));
		o2.addFase(new Fases(2, "TA", 1, (float)1.3));
		o2.addComponent(new Components("50001", 1, (float)0.4));
		o2.addComponent(new Components("60001", 2, (float)2.5));
		ordres.add(o2);
		Ordres o4 = new Ordres(10204, "15011", 13);
		o4.addFase(new Fases(1, "FO", 1, (float)18.2));
		o4.addFase(new Fases(2, "TA", 1, (float)2.3));
		o4.addComponent(new Components("50001", 1, (float)0.24));
		o4.addComponent(new Components("60001", 2, (float)3.51));
		ordres.add(o4);
		Ordres o5 = new Ordres(10205, "10120", 10);
		o5.addFase(new Fases(1, "PI", 3, (float)0.23));
		o5.addFase(new Fases(2, "MU", 2, (float)5.3));
		o5.addComponent(new Components("20001", 1, (float)0.34));
		o5.addComponent(new Components("15010", 1, (float)1));
		o5.addComponent(new Components("30010", 2, (float)4));
		o5.addComponent(new Components("30011", 2, (float)4));
		o5.addComponent(new Components("40010", 2, (float)0.5));
		ordres.add(o5);
		Ordres o6 = new Ordres(10206, "10121", 15);
		o6.addFase(new Fases(1, "PI", 3, (float)0.44));
		o6.addFase(new Fases(2, "MU", 2, (float)8));
		o6.addComponent(new Components("20002", 1, (float)0.45));
		o6.addComponent(new Components("15011", 1, (float)1));
		o6.addComponent(new Components("30010", 2, (float)2));
		o6.addComponent(new Components("30011", 2, (float)2));
		o6.addComponent(new Components("40010", 2, (float)0.5));
		ordres.add(o6);
		Ordres o7 = new Ordres(10207, "15010", 20);
		o7.addFase(new Fases(1, "FO", 1, (float)10.2));
		o7.addFase(new Fases(2, "TA", 1, (float)1.3));
		o7.addComponent(new Components("50001", 1, (float)0.4));
		o7.addComponent(new Components("60001", 2, (float)2.5));
		ordres.add(o7);
		Ordres o8 = new Ordres(10208, "15011", 13);
		o8.addFase(new Fases(1, "FO", 1, (float)18.2));
		o8.addFase(new Fases(2, "TA", 1, (float)2.3));
		o8.addComponent(new Components("50001", 1, (float)0.24));
		o8.addComponent(new Components("60001", 2, (float)3.51));
		ordres.add(o8);
		tasques = new ArrayList<Tasques>();
	}
	
	public String getDescripcio(String article){
		if (articles.containsKey(article)){
			return articles.get(article);
		} else {
			return null;
		}
	}
	
	public String getNom(String operari){
		if (operaris.containsKey(operari)){
			return operaris.get(operari).getNom();
		} else {
			return null;
		}
	}
	
	public List<Maquines> getMaquines(){
		return maquines;
	}
	
	public List<Ordres> getOrdres(){
		return ordres;
	}
	
	public Ordres getOrdre(long ordre){
		Ordres ord = null;
		for (Iterator<Ordres> it = ordres.iterator(); it.hasNext();){
			Ordres or = it.next();
			if (or.getCodi() == ordre){
				ord = or;
			}
		}
		return ord;
	}

	public Tasques getTascaActiva(String maquina){
		Tasques tasca = null;
		for (Iterator<Tasques> it = tasques.iterator(); it.hasNext();){
			Tasques tasc = it.next();
			if (tasc.getMaquina().equalsIgnoreCase(maquina) && tasc.getDataFinal().compareTo(tasc.getDataInici()) == 0){
				tasca = tasc;
			}
		}
		return tasca;
	}
	
	public List<Tasques> getTasquesActives(){
		List<Tasques> tqs = new ArrayList<Tasques>();
		for (Iterator<Tasques> it = tasques.iterator(); it.hasNext();){
			Tasques tasc = it.next();
			if (tasc.getDataFinal().compareTo(tasc.getDataInici()) == 0){
				tqs.add(tasc);
			}
		}
		return tqs;
	}

	public void setTasca(Tasques t){
		if (getTascaActiva(t.getMaquina()) == null){
			tasques.add(t);
		}
	}
	
	public String setNotificacio(String maquina, Notificacions not){
		if (getTascaActiva(maquina) == null){
			return "No hi ha cap tasca activa en la mquina "+maquina;
		} else {
			getTascaActiva(maquina).addNotificacions(not);
			return null;
		}
	}
	
	public String setAssignats(String maquina, String operari){
		if (getTascaActiva(maquina) == null){
			return "No hi ha cap tasca activa en la mquina "+maquina;
		} else {
			getTascaActiva(maquina).addAssignats(operari);
			return null;
		}
	}
}
