package integracio.baseDades;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;

public class Ordres {
	private long codi;
	private String article;
	private float quantitat;
	private List<Fases> fases;
	private List<Components> components;
	
	public Ordres(long codi, String article, float quantitat) {
		super();
		this.codi = codi;
		this.article = article;
		this.quantitat = quantitat;
		fases = new ArrayList<Fases>();
		components = new ArrayList<Components>();
	}

	public long getCodi() {
		return codi;
	}

	public void setCodi(long codi) {
		this.codi = codi;
	}

	public String getArticle() {
		return article;
	}

	public void setArticle(String article) {
		this.article = article;
	}

	public float getQuantitat() {
		return quantitat;
	}

	public void setQuantitat(float quantitat) {
		this.quantitat = quantitat;
	}

	public List<Fases> getFases() {
		return fases;
	}

	public void addFase(Fases fase) {
		this.fases.add(fase);
	}

	public List<Components> getComponents() {
		return components;
	}

	public void addComponent(Components component) {
		this.components.add(component);
	}
	
	public float getPendentFase(int fase){
		float pendent = quantitat;
		for (Iterator<Fases> it = fases.iterator(); it.hasNext();){
			Fases f = it.next();
			if (f.getNumFase()==fase){
				pendent = pendent - f.getFet();
			}
		}
		return pendent;
	}
	
	public String getMaquina(int fase){
		String maquina = "";
		for (Iterator<Fases> it = fases.iterator(); it.hasNext();){
			Fases f = it.next();
			if (f.getNumFase()==fase){
				maquina = f.getMaquina();
			}
		}
		return maquina;
	}
}
