package integracio.baseDades;

import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

public class Tasques {
	private String maquina;
	private Date dataInici;
	private Date dataFinal;
	private long OrdreActual;
	private int faseActual;
	private List<String> assignats;
	private List<Notificacions> notificacions;
	
	public Tasques(String maquina) {
		super();
		this.maquina = maquina;
		this.dataInici = new Date();
		this.dataFinal = dataInici;
		this.OrdreActual = 0;
		this.faseActual = 0;
		assignats = new ArrayList<String>();
		notificacions = new ArrayList<Notificacions>();
	}

	public String getMaquina() {
		return maquina;
	}

	public void setMaquina(String maquina) {
		this.maquina = maquina;
	}

	public Date getDataInici() {
		return dataInici;
	}

	public void setDataInici(Date dataInici) {
		this.dataInici = dataInici;
	}

	public Date getDataFinal() {
		return dataFinal;
	}

	public void setDataFinal(Date dataFinal) {
		this.dataFinal = dataFinal;
	}

	public long getOrdreActual() {
		return OrdreActual;
	}

	public void setOrdreActual(long ordreActual) {
		OrdreActual = ordreActual;
	}

	public int getFaseActual() {
		return faseActual;
	}

	public void setFaseActual(int faseActual) {
		this.faseActual = faseActual;
	}

	public List<String> getAssignats() {
		return assignats;
	}

	public void addAssignats(String operari) {
		this.assignats.add(operari);
	}

	public List<Notificacions> getNotificacions() {
		return notificacions;
	}

	public void addNotificacions(Notificacions notificacion) {
		this.notificacions.add(notificacion);
	}
	
	public float rendiment(){
		int operaris = assignats.size();
		float tempsReal = (dataFinal.getTime() - dataInici.getTime()) / 1000;
		if (tempsReal == 0){
			tempsReal = ((new Date()).getTime() - dataInici.getTime()) / 1000;
		}
		tempsReal = tempsReal * operaris;
		float tempsConcedit = 0;
		for (Iterator<Notificacions> it = notificacions.iterator(); it.hasNext();){
			Notificacions not = it.next();
			tempsConcedit = tempsConcedit + not.getTempsConcedit(); 
		}
		if (tempsReal > 0){
			return (100 * tempsConcedit) / tempsReal;
		} else {
			return 0;
		}
	}

}
