package logica;

import java.util.List;
import java.util.Iterator;
import java.util.Date;

import integracio.baseDades.*;

public class LogicaFacade {
	public LogicaFacade() {
		super();
	}
	
	public List<Maquines> getMaquines(){
		return GestorDB.getDB().getMaquines();
	}
	
	public Tasques getTascaActual(String maquina){
		return GestorDB.getDB().getTascaActiva(maquina);
	}
	
	public String getNomOperari(String operari){
		return GestorDB.getDB().getNom(operari);
	}
	
	public String getDescripcioArticle(String article){
		return GestorDB.getDB().getDescripcio(article);
	}
	
	public List<Ordres > getOrdres(){
		return GestorDB.getDB().getOrdres();
	}
	
	public Ordres getOrdre(long codi){
		Ordres or = null;
		List<Ordres> ors = GestorDB.getDB().getOrdres();
		for (Iterator<Ordres> it = ors.iterator(); it.hasNext();){
			Ordres o = it.next();
			if (o.getCodi()==codi){
				or = o;
			}
		}
		return or;
	}

	public String getMaquina(long ordre, int fase){
		if (getOrdre(ordre)==null){
			return "";
		} else {
			return getOrdre(ordre).getMaquina(fase);
		}
	}
	
	public String estaAssignat(String operari){
		String maquina = "";
		for (Iterator<Tasques> it = GestorDB.getDB().getTasquesActives().iterator(); it.hasNext();){
			Tasques t = it.next();
			for (Iterator<String> ito = t.getAssignats().iterator(); ito.hasNext();){
				if (ito.next().equalsIgnoreCase(operari)){
					maquina = t.getMaquina();
				}
			}
		}		
		return maquina;
	}
	
	public Tasques novaTasca(String maquina, String operari){
		Tasques t = new Tasques(maquina);
		t.addAssignats(operari);
		GestorDB.getDB().setTasca(t);
		return t;
	}
	
	public void desassigna(String maquina){
		Tasques t = getTascaActual(maquina);
		if (t!=null){
			t.setDataFinal(new Date());
		}
	}
	
	public void notifica(Tasques t, float q){
		Ordres or = GestorDB.getDB().getOrdre(t.getOrdreActual());
		float tempsUnitari = 0;
		if (or.getPendentFase(t.getFaseActual())>=q){
			for (Iterator<Fases> it = or.getFases().iterator();it.hasNext();){
				Fases f = it.next();
				if (f.getNumFase()==t.getFaseActual()){
					tempsUnitari = f.getTempsUnitari();
					f.setFet(f.getFet()+q);
				}
			}
		}
		t.addNotificacions(new Notificacions(t.getOrdreActual(), t.getFaseActual(), q, q*tempsUnitari));
		if (or.getPendentFase(t.getFaseActual())==0){
			t.setOrdreActual(0);
			t.setFaseActual(0);
		}
	}
}
